-- phpMyAdmin SQL Dump
-- version 3.4.10.1deb1
-- http://www.phpmyadmin.net
--
-- Host: localhost
-- Erstellungszeit: 10. Mai 2017 um 08:24
-- Server Version: 5.5.54
-- PHP-Version: 5.3.10-1ubuntu3.26

SET SQL_MODE="NO_AUTO_VALUE_ON_ZERO";
SET time_zone = "+00:00";


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;

--
-- Datenbank: `LeasDB`
--

DELIMITER $$
--
-- Prozeduren
--
CREATE DEFINER=`root`@`localhost` PROCEDURE `p_crystalline`(pathway INTEGER(1))
BEGIN
/* 	procedure information
	ALL transfers for databases
		SOURCE: mylea_beta
		TARGET: flash_04
	######## IF DATABASES CHANGE, SEARCH AND REPLACE IN THE WHOLE DOCUMENT! ########
	
	pathway values
	01: populate database with standard values (adaptive curriculum and mylea_beta subject preparation)
	02: populate database with people (student and teachers)
	03: populate database with competencies as skills and learning objects
	04: populate database with activities as skills and learning objects
	
*/
	IF pathway = 1
		THEN
		-- subject
		INSERT INTO flash_04.subject (subject_name)
		VALUES 
		('Science'),
		('Leas Subject');
		-- topic
		INSERT INTO flash_04.topic (topic_name, subject_id)
			VALUES 
				('Adaptations', 1),
				('Life Science', 1),
				('Leas Topic', 2)
		;
		-- concept
		INSERT INTO flash_04.concept (concept_name, topic_id)
			VALUES 
			('7th Grade Science', 1),
			('Grade 8', 2)
		;
		-- skill_group
		INSERT INTO flash_04.skill_group (
			skill_group_ext_id,
			concept_id,
			skill_group_name)
		VALUES (
			'e7bc19a34bae068963ea81609ba06cbc', 
			1, 
			'Biological Adaptations: Bird Beaks'
		);
		INSERT INTO flash_04.skill_group (
			skill_group_ext_id,
			concept_id,
			skill_group_name)
		VALUES (
			'657bee95167ca5fa5b069c05c9324185', 
			1, 
			'Comparing the Adaptations of Organisms in Different Ecosystems'
		);
		INSERT INTO flash_04.skill_group (
			skill_group_ext_id,
			concept_id,
			skill_group_name)
		VALUES (
			'7d5e9bc15f52ba2e25fa32d58d01b6ad', 
			1, 
			'Behavioral and Physiological Adaptations of Organisms'
		);
		INSERT INTO flash_04.skill_group (
			skill_group_ext_id,
			concept_id,
			skill_group_name)
		VALUES (
			'92608152-203C-11E0-BA9A-13B9BCAA0334',
			2,
			'Understand the predictability of characteristics being passed from parents to offspring.'
		);

	ELSEIF pathway = 2
		THEN
		-- transfer of people 01 - students for student table (ext_id01, ext_id02, first and last name, origin)
		INSERT LOW_PRIORITY
		INTO flash_04.student (student_ext_id01, student_ext_id02, first_name, last_name, origin)
		SELECT
			stu.id,
			CASE 
				WHEN CAST(extstu.extid AS char character set utf8) = CAST(extlnk.extid AS char character set utf8)
					THEN CAST(extstu.extid AS char character set utf8)
					WHEN CAST(extstu.extid AS char character set utf8) IS NULL
					THEN CAST(extlnk.extid AS char character set utf8)
					ELSE CAST(extstu.extid AS char character set utf8)
			END AS "extid"
			, stu.firstname
			, stu.surname
			, stu.language
		FROM mylea_beta.people AS stu
		LEFT JOIN
		mylea_beta.student_has_extid AS extstu
		ON
		extstu.studid = stu.id
		LEFT JOIN
		mylea_beta.extlink AS extlnk
		ON 
		extlnk.internalstdid = stu.id
		WHERE 
		stu.role = 2
		ORDER BY stu.id ASC
		;
		-- transfer of people 02 - students for student administration table 
		INSERT LOW_PRIORITY
		INTO flash_04.student_administration (
			student_id, 
			school_id, 
			group_id,
			teacher_id,
			school_name, 
			group_name, 
			group_teacher, 
			student_level)
		SELECT
			fla.student_id AS 'student''s id'
			, stu.schoolid AS 'student''s school id'
			, gru.id AS 'group''s id'
			, tea.id AS 'teacher''s id'
			, schoo.name AS 'school''s name'
			, gru.name AS 'group''s name'
			, CONCAT_WS(', ',tea.surname,tea.firstname) AS 'teacher''s name'
			, lvl.name AS 'student''s level'
		FROM mylea_beta.people AS stu
		LEFT JOIN
		mylea_beta.group_has_students AS gruHstu
		ON 
		gruHstu.studentid = stu.id
		LEFT JOIN
		mylea_beta.groups AS gru
		ON 
		gruHstu.groupid = gru.id
		LEFT JOIN
		mylea_beta.schools AS schoo
		ON 
		gru.schoolid = schoo.id
		LEFT JOIN
		mylea_beta.teacher_has_groups AS teaHgru
		ON 
		gru.id = teaHgru.groupid
		LEFT JOIN
		mylea_beta.people AS tea
		ON
		teaHgru.teacherid = tea.id
		LEFT JOIN
		mylea_beta.student_has_levels AS stuHlvl
		ON stu.id = stuHlvl.studid
		LEFT JOIN
		mylea_beta.levels AS lvl
		ON
		stuHlvl.levelid = lvl.id
		LEFT JOIN
		flash_04.student AS fla
		ON
		fla.student_ext_id01 = stu.id
		ORDER BY stu.id ASC
		;
-- okay on the server until here
	ELSEIF pathway = 3
		THEN
		-- transfer of skills - competencies 01 -> competencies as skills
		INSERT LOW_PRIORITY
		INTO flash_04.skill 
			(
			skill_ext_id, 
			skill_name, 
			skill_desc, 
			skill_value, 
			skill_weight
			)
		SELECT
			CONCAT('comp_', CAST(comp.id AS CHAR)) "competency id"
			, CAST(comp.name AS char character set utf8) "competency name"
			, CAST(comp.description AS char character set utf8) "competency description"
			, CAST(comp.value AS char character set utf8) "competency value"
			, comp.weight "competency weight"
		FROM mylea_beta.competencies AS comp
		ORDER BY comp.id ASC
		;
		-- transfer of skills - competencies 02 -> each competency as its own learning object
		INSERT LOW_PRIORITY
		INTO flash_04.learning_object 
			(
			learn_obj_ext_id, 
			learn_obj_name
			)
		SELECT
			CONCAT('comp_', CAST(comp.id AS CHAR)) "competency as learning object id"
			, CAST(comp.name AS char character set utf8) "competency as learning object name"
		FROM mylea_beta.competencies AS comp
		ORDER BY comp.id ASC
		;
		-- transfer of skills - competencies 03 -> linkage of learning objects to skills
		INSERT LOW_PRIORITY
		INTO flash_04.skill_ball
			(learn_obj_id
			, skill_id)
		SELECT
			l_obj.learn_obj_id
			, ski.skill_id
		FROM flash_04.learning_object AS l_obj
			, flash_04.skill AS ski
		WHERE l_obj.learn_obj_ext_id = ski.skill_ext_id
		ORDER BY ski.skill_id
		;

		-- transfer of skills - competencies 04 -> dependencies
		INSERT LOW_PRIORITY
		INTO
		flash_04.cbkst_skill
			(prerequisite_skill_id
			, dependent_skill_id
			)
		SELECT
		ski01.skill_id AS 'Fla_prerequisite'
		, ski02.skill_id AS 'Fla_dependent'
		FROM mylea_beta.dependencies AS deps
		JOIN 
		flash_04.skill AS ski01
		ON
		deps.competenceid = CAST(SUBSTRING(ski01.skill_ext_id,6) AS SIGNED INTEGER)
		JOIN
		flash_04.skill AS ski02
		ON
		deps.dependentid = CAST(SUBSTRING(ski02.skill_ext_id,6) AS SIGNED INTEGER)
		;
		
		
	ELSEIF pathway = 4
		THEN
		-- transfer of activities 01 -> every activity as a learning object
		INSERT LOW_PRIORITY
		INTO flash_04.learning_object
			(learn_obj_ext_id
			, learn_obj_name
			, learn_obj_weight
			, learn_obj_influence
			)
		SELECT
			CONCAT('activ_', CAST(activ.id AS CHAR)) "activity as learning object id"
			, CAST(activ.name AS char character set utf8) "activity as learning object name"
			, activ.threshold "activity threshold as learning object weight"
			, activ.activityinfluence "activity influence as learning object influence"
		FROM mylea_beta.activities AS activ
		LEFT OUTER JOIN
		mylea_beta.activities_has_subjects AS act_subs
		ON
		act_subs.activityid = activ.id
		WHERE
		act_subs.subjectid IS NULL
		;
		-- transfer of activities 02 -> subjects to concepts for learning_objects
		INSERT LOW_PRIORITY
		INTO flash_04.concept
			(concept_ext_id
			, topic_id
			, concept_name
			)
		SELECT
			CONCAT
				('subs_'
				, CAST(subs.id AS char character set utf8)
				) "subject id"
			, (SELECT
				topic_id
				FROM flash_04.topic
				WHERE topic_name = 'Leas Topic')
			, subs.name
		FROM mylea_beta.subjects AS subs
		;
		-- transfer of activities 03 -> transfer of the subject<->competency relationship via skill club
		 -- concept VIA subjects VIA subject_has_competencies VIA competencies TO skill
		INSERT LOW_PRIORITY
		INTO flash_04.skill_club
			(concept_id
			, skill_id)
		SELECT
			DISTINCT
			con.concept_id AS 'con_id'
			, ski.skill_id AS 'ski_id'
		FROM 
		flash_04.concept AS con
		JOIN
		mylea_beta.subjects AS subs
		ON
		CAST(SUBSTRING(concept_ext_id,6) AS SIGNED INTEGER) = subs.id
		JOIN
		mylea_beta.subject_has_competencies AS sub_comp
		ON
		sub_comp.subjectid = subs.id
		JOIN
		mylea_beta.competencies AS comp
		ON
		sub_comp.compid = comp.id
		JOIN 
		flash_04.skill AS ski
		ON 
		CAST(SUBSTRING(skill_ext_id,6) AS SIGNED INTEGER) = comp.id
		WHERE 
			SUBSTRING(skill_ext_id,1,5) = 'comp_'
			AND
			SUBSTRING(concept_ext_id,1,5) = 'subs_'
		ORDER BY skill_id ASC
		;
		-- transfer of activities 04 -> transfer of the subject<-activity->competency relationship via skill club
		 -- concept VIA subjects VIA activities_has_subjects VIA activities VIA activities_has_competencies VIA competencies TO skill
		INSERT LOW_PRIORITY
		INTO flash_04.skill_club
			(concept_id
			, skill_id)
		SELECT 
			DISTINCT
			con.concept_id AS 'con_id'
			, ski.skill_id AS 'ski_id'
		FROM 
		flash_04.concept AS con
		JOIN
		mylea_beta.subjects AS subs
		ON
		CAST(SUBSTRING(concept_ext_id,6) AS SIGNED INTEGER) = subs.id
		JOIN
		mylea_beta.activities_has_subjects AS act_subs
		ON 
		act_subs.subjectid = subs.id
		JOIN
		mylea_beta.activities AS activ
		ON 
		act_subs.activityid = activ.id
		JOIN
		mylea_beta.activities_has_competencies AS act_comp
		ON
		act_comp.activityid = activ.id
		JOIN
		mylea_beta.competencies AS comp
		ON
		act_comp.competenceid = comp.id
		JOIN 
		flash_04.skill AS ski
		ON 
		CAST(SUBSTRING(skill_ext_id,6) AS SIGNED INTEGER) = comp.id
		WHERE 
			SUBSTRING(skill_ext_id,1,5) = 'comp_'
			AND
			SUBSTRING(concept_ext_id,1,5) = 'subs_'
		ORDER BY skill_id ASC
		;
		-- transfer of activities 05 -> activities with subjects as learning objects with concepts
		 -- is independent from the activity <-> competency <-> subject linkage
		INSERT LOW_PRIORITY
		INTO
		flash_04.learning_object
			(learn_obj_ext_id
			, learn_obj_name
			, learn_obj_weight
			, learn_obj_influence
			, concept_id
			)
		SELECT
			CONCAT('activ_', CAST(activ.id AS CHAR)) "activity as learning object external id"
			, CAST(activ.name AS char character set utf8) "activity as learning object name"
			, activ.threshold "activity threshold as learning object weight"
			, activ.activityinfluence "activity influence as learning object influence"
			, con.concept_id "con_id"
		FROM mylea_beta.activities AS activ
		LEFT JOIN 
		mylea_beta.activities_has_subjects AS act_subs
		ON
		act_subs.activityid = activ.id
		LEFT JOIN
		mylea_beta.subjects AS subs
		ON
		act_subs.subjectid = subs.id
		JOIN
		flash_04.concept AS con
		ON
		CAST(SUBSTRING(concept_ext_id,6) AS SIGNED INTEGER) = subs.id
		;
		-- transfer of activities 06 -> link of learning object to skill as a mirror of activity<->competency
		INSERT LOW_PRIORITY
		INTO
		flash_04.skill_ball
			(
			skill_id
			, learn_obj_id
			)
		SELECT
			ski.skill_id AS 'ski_id'
			, l_obj.learn_obj_id AS 'l_obj_id'
		FROM
		flash_04.skill AS ski
		JOIN
		mylea_beta.competencies AS comp
		ON 
		CAST(SUBSTRING(ski.skill_ext_id,6) AS SIGNED INTEGER) = comp.id
		JOIN
		mylea_beta.activities_has_competencies AS act_comp
		ON
		act_comp.competenceid = comp.id
		JOIN
		mylea_beta.activities AS activ
		ON
		act_comp.activityid = activ.id
		JOIN
		flash_04.learning_object AS l_obj
		ON
		CAST(SUBSTRING(l_obj.learn_obj_ext_id,7) AS SIGNED INTEGER) = activ.id
		WHERE SUBSTRING(l_obj.learn_obj_ext_id,1,6) = 'activ_'
		ORDER BY ski.skill_id ASC
		;
		-- transfer of activities 07 -> transfer of the activity<->competency relationship via skill ball
		 -- skill VIA competencies VIA activities_has_competencies VIA activities TO learn_object
		INSERT LOW_PRIORITY
		INTO
		flash_04.skill_ball
			(
			learn_obj_id
			, skill_id
			)
		SELECT 
			-- DISTINCT
			l_obj.learn_obj_id AS 'l_obj_id'
			, ski.skill_id AS 'ski_id'
		FROM
		mylea_beta.activities AS activ
		LEFT OUTER JOIN
		mylea_beta.activities_has_subjects AS act_subs
		ON
		act_subs.activityid = activ.id
		JOIN
		mylea_beta.activities_has_competencies AS act_comp
		ON
		act_comp.activityid = activ.id
		JOIN
		mylea_beta.competencies AS comp
		ON
		act_comp.competenceid = comp.id
		JOIN
		flash_04.skill AS ski
		ON 
		CAST(SUBSTRING(skill_ext_id,6) AS SIGNED INTEGER) = comp.id
		JOIN
		flash_04.learning_object AS l_obj
		ON
		CAST(SUBSTRING(l_obj.learn_obj_ext_id,7) AS SIGNED INTEGER) = activ.id
		WHERE
			act_subs.activityid IS NULL
			AND
			SUBSTRING(skill_ext_id,1,5) = 'comp_'
			AND
			SUBSTRING(l_obj.learn_obj_ext_id,1,6) = 'activ_'
		;

	ELSE
		BEGIN
		END;

	END IF;

END$$

DELIMITER ;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `activities`
--

CREATE TABLE IF NOT EXISTS `activities` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `schoolid` int(11) DEFAULT NULL,
  `name` varchar(255) NOT NULL,
  `icon` varchar(50) NOT NULL,
  `threshold` float DEFAULT '0.5',
  `position` int(11) NOT NULL,
  `activityinfluence` float NOT NULL,
  `subject` int(11) NOT NULL,
  `datasource` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=307 ;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `activitieslog`
--

CREATE TABLE IF NOT EXISTS `activitieslog` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `activityid` int(11) NOT NULL,
  `mindmapid` int(11) NOT NULL,
  `groupid` int(11) NOT NULL,
  `teacherid` int(11) NOT NULL,
  `value` double DEFAULT NULL,
  `studentid` int(11) NOT NULL,
  `timestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `datasourceid` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=13248 ;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `activities_has_char`
--

CREATE TABLE IF NOT EXISTS `activities_has_char` (
  `activityid` int(11) NOT NULL,
  `charid` int(11) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `activities_has_competencies`
--

CREATE TABLE IF NOT EXISTS `activities_has_competencies` (
  `activityid` int(11) NOT NULL,
  `competenceid` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`activityid`,`competenceid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `activities_has_subjects`
--

CREATE TABLE IF NOT EXISTS `activities_has_subjects` (
  `activityid` int(11) NOT NULL,
  `subjectid` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`activityid`,`subjectid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `activities_has_teachers`
--

CREATE TABLE IF NOT EXISTS `activities_has_teachers` (
  `activityid` int(11) NOT NULL,
  `teacherid` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`activityid`,`teacherid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `activities_have_competencies`
--

CREATE TABLE IF NOT EXISTS `activities_have_competencies` (
  `activityid` int(11) DEFAULT NULL,
  `competencyid` int(11) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `activities_have_extcolumn`
--

CREATE TABLE IF NOT EXISTS `activities_have_extcolumn` (
  `activityid` int(11) DEFAULT NULL,
  `source` varchar(45) DEFAULT NULL,
  `column_name` varchar(250) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `activity_has_images`
--

CREATE TABLE IF NOT EXISTS `activity_has_images` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `icon` varchar(255) CHARACTER SET latin1 DEFAULT NULL,
  `fileSize` varchar(255) CHARACTER SET latin1 DEFAULT NULL,
  `webPath` varchar(255) CHARACTER SET latin1 DEFAULT NULL,
  `systemPath` varchar(255) CHARACTER SET latin1 DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=30 ;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `characteristcs`
--

CREATE TABLE IF NOT EXISTS `characteristcs` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=5 ;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `competencies`
--

CREATE TABLE IF NOT EXISTS `competencies` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) CHARACTER SET utf8 DEFAULT NULL,
  `description` text CHARACTER SET latin1,
  `prerequisites` text CHARACTER SET latin1,
  `parentid` int(11) DEFAULT NULL,
  `childlevel` int(11) DEFAULT '1',
  `schoolid` int(11) NOT NULL,
  `value` varchar(255) CHARACTER SET latin1 NOT NULL,
  `weight` int(11) NOT NULL,
  `mindmapid` int(11) NOT NULL,
  `datasourceid` int(11) NOT NULL,
  `competencyinfluence` float NOT NULL,
  `subjectid` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `parentid` (`parentid`),
  KEY `name` (`name`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=3251 ;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `competency_data`
--

CREATE TABLE IF NOT EXISTS `competency_data` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `compid` int(11) DEFAULT NULL,
  `groupid` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=689 ;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `competency_has_datasource`
--

CREATE TABLE IF NOT EXISTS `competency_has_datasource` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `compid` int(11) DEFAULT NULL,
  `dataid` int(11) DEFAULT NULL,
  `wieght` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=183 ;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `competency_has_levels`
--

CREATE TABLE IF NOT EXISTS `competency_has_levels` (
  `compid` int(11) DEFAULT NULL,
  `levelid` int(11) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `complog`
--

CREATE TABLE IF NOT EXISTS `complog` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `compid` varchar(150) NOT NULL,
  `studid` int(11) NOT NULL,
  `settingsid` int(11) DEFAULT NULL,
  `teacherid` int(11) NOT NULL,
  `value` double DEFAULT NULL,
  `timestamp` bigint(20) NOT NULL,
  `subjectid` int(11) DEFAULT NULL,
  `datasourceid` int(11) NOT NULL,
  `groupid` int(11) NOT NULL,
  `approved` int(11) DEFAULT NULL,
  `contributorid` int(11) DEFAULT NULL,
  `competencyinfluence` int(11) DEFAULT NULL,
  `depreciation` int(11) DEFAULT '-1',
  `aretefact` int(11) DEFAULT NULL,
  `tags` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `compid` (`compid`),
  KEY `studid` (`studid`),
  KEY `compid_2` (`compid`,`studid`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=164564 ;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `datasource`
--

CREATE TABLE IF NOT EXISTS `datasource` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) CHARACTER SET latin1 DEFAULT NULL,
  `schoolid` int(11) DEFAULT NULL,
  `subject` int(11) NOT NULL,
  `token` varchar(25) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=59 ;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `dependencies`
--

CREATE TABLE IF NOT EXISTS `dependencies` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `competenceid` int(11) NOT NULL,
  `dependentid` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1333 ;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `dependencies_space`
--

CREATE TABLE IF NOT EXISTS `dependencies_space` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `competenceid` int(11) NOT NULL,
  `dependentid` int(11) NOT NULL,
  `subjectid` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=574 ;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `extlink`
--

CREATE TABLE IF NOT EXISTS `extlink` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `internalstdid` int(11) NOT NULL,
  `extid` varchar(255) NOT NULL,
  `teacherid` int(11) NOT NULL,
  `extteacher` varchar(255) NOT NULL,
  `datasourceid` int(11) NOT NULL,
  `schoolid` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=502 ;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `feedback`
--

CREATE TABLE IF NOT EXISTS `feedback` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `subjectid` int(11) DEFAULT NULL,
  `studid` int(11) NOT NULL,
  `teacherid` int(11) NOT NULL,
  `timestamp` bigint(20) DEFAULT NULL,
  `feedback` longtext CHARACTER SET latin1,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=4 ;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `groups`
--

CREATE TABLE IF NOT EXISTS `groups` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(200) CHARACTER SET latin1 NOT NULL,
  `icon` varchar(200) CHARACTER SET latin1 NOT NULL DEFAULT 'dummy.gif',
  `schoolid` int(11) DEFAULT NULL,
  `position` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=167 ;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `group_has_images`
--

CREATE TABLE IF NOT EXISTS `group_has_images` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `icon` varchar(255) CHARACTER SET latin1 DEFAULT NULL,
  `fileSize` varchar(255) CHARACTER SET latin1 DEFAULT NULL,
  `webPath` varchar(255) CHARACTER SET latin1 DEFAULT NULL,
  `systemPath` varchar(255) CHARACTER SET latin1 DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=9 ;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `group_has_students`
--

CREATE TABLE IF NOT EXISTS `group_has_students` (
  `groupid` int(11) NOT NULL,
  `studentid` int(11) NOT NULL,
  PRIMARY KEY (`groupid`,`studentid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `group_has_subjects`
--

CREATE TABLE IF NOT EXISTS `group_has_subjects` (
  `groupid` int(11) NOT NULL DEFAULT '0',
  `subjectid` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`groupid`,`subjectid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `image`
--

CREATE TABLE IF NOT EXISTS `image` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `icon` varchar(255) CHARACTER SET latin1 DEFAULT NULL,
  `fileSize` varchar(255) CHARACTER SET latin1 DEFAULT NULL,
  `webPath` varchar(255) CHARACTER SET latin1 DEFAULT NULL,
  `systemPath` varchar(255) CHARACTER SET latin1 DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=54 ;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `levels`
--

CREATE TABLE IF NOT EXISTS `levels` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `schoolid` int(11) DEFAULT NULL,
  `name` varchar(200) CHARACTER SET latin1 DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=10 ;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `mindmap`
--

CREATE TABLE IF NOT EXISTS `mindmap` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `teacherid` int(11) NOT NULL,
  `name` mediumtext CHARACTER SET utf8 COLLATE utf8_bin NOT NULL,
  `data` mediumtext CHARACTER SET utf8 COLLATE utf8_bin NOT NULL,
  `groupid` int(11) NOT NULL,
  `subjectid` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=119 ;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `mindmapcompetencies`
--

CREATE TABLE IF NOT EXISTS `mindmapcompetencies` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` mediumtext CHARACTER SET utf8 COLLATE utf8_bin NOT NULL,
  `mindmapid` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1549 ;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `mindmapevidences`
--

CREATE TABLE IF NOT EXISTS `mindmapevidences` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` mediumtext CHARACTER SET utf8 COLLATE utf8_bin NOT NULL,
  `competenceid` int(11) NOT NULL,
  `priority` double NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=3464 ;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `mindmap_has_teacher_has_subjects`
--

CREATE TABLE IF NOT EXISTS `mindmap_has_teacher_has_subjects` (
  `mindmapid` int(11) NOT NULL,
  `teacherid` int(11) NOT NULL,
  `subjectid` int(11) NOT NULL,
  PRIMARY KEY (`mindmapid`,`teacherid`,`subjectid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `mytools`
--

CREATE TABLE IF NOT EXISTS `mytools` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) COLLATE utf8_unicode_ci NOT NULL,
  `url` varchar(100) COLLATE utf8_unicode_ci NOT NULL,
  `icon` varchar(100) COLLATE utf8_unicode_ci NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=4 ;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `notes`
--

CREATE TABLE IF NOT EXISTS `notes` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `subjectid` int(11) DEFAULT NULL,
  `studid` int(11) NOT NULL,
  `settingsid` int(11) NOT NULL,
  `teacherid` int(11) NOT NULL,
  `timestamp` bigint(20) DEFAULT NULL,
  `note` longtext CHARACTER SET latin1,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=3 ;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `olmevidence`
--

CREATE TABLE IF NOT EXISTS `olmevidence` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `leasid` int(11) NOT NULL,
  `competencyid` int(11) NOT NULL,
  `groupid` int(11) NOT NULL,
  `userid` int(11) NOT NULL,
  `datasourceid` int(11) NOT NULL,
  `value` int(11) NOT NULL,
  `activityid` int(11) NOT NULL,
  `timestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `people`
--

CREATE TABLE IF NOT EXISTS `people` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `userid` varchar(50) CHARACTER SET latin1 NOT NULL,
  `password` varchar(50) CHARACTER SET latin1 NOT NULL,
  `firstname` varchar(100) CHARACTER SET latin1 NOT NULL,
  `surname` varchar(100) CHARACTER SET latin1 NOT NULL,
  `icon` varchar(200) CHARACTER SET latin1 DEFAULT NULL,
  `schoolid` int(11) DEFAULT NULL,
  `language` varchar(100) CHARACTER SET latin1 NOT NULL,
  `role` int(11) NOT NULL,
  `level` int(11) DEFAULT NULL,
  `password_` varchar(255) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=2758 ;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `rawdata`
--

CREATE TABLE IF NOT EXISTS `rawdata` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `datasourceid` int(11) NOT NULL,
  `activityid` int(11) NOT NULL,
  `value` float NOT NULL,
  `minvalue` float NOT NULL,
  `maxvalue` float NOT NULL,
  `timestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `teacherid` varchar(100) NOT NULL,
  `studid` varchar(100) NOT NULL,
  `val2` float NOT NULL,
  `min2` float NOT NULL,
  `max2` float NOT NULL,
  `val3` float NOT NULL,
  `min3` float NOT NULL,
  `max3` float NOT NULL,
  `val4` float NOT NULL,
  `min4` float NOT NULL,
  `max4` float NOT NULL,
  `val5` float NOT NULL,
  `min5` float NOT NULL,
  `max5` float NOT NULL,
  `token` varchar(25) NOT NULL,
  `status` varchar(100) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=48391 ;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `schools`
--

CREATE TABLE IF NOT EXISTS `schools` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` text CHARACTER SET latin1 NOT NULL,
  `currentsettings` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=31 ;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `settings`
--

CREATE TABLE IF NOT EXISTS `settings` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `termname` varchar(200) CHARACTER SET latin1 DEFAULT NULL,
  `schoolid` int(11) DEFAULT NULL,
  `year` varchar(50) CHARACTER SET latin1 DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=19 ;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `studentevidences`
--

CREATE TABLE IF NOT EXISTS `studentevidences` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `studentid` int(11) NOT NULL,
  `evidence` text NOT NULL,
  `value` tinyint(4) NOT NULL,
  `timestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1643 ;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `student_has_extid`
--

CREATE TABLE IF NOT EXISTS `student_has_extid` (
  `studid` int(11) NOT NULL,
  `source` varchar(255) NOT NULL,
  `extid` varchar(11) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `student_has_levels`
--

CREATE TABLE IF NOT EXISTS `student_has_levels` (
  `studid` int(11) NOT NULL,
  `levelid` int(11) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `subjects`
--

CREATE TABLE IF NOT EXISTS `subjects` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(200) CHARACTER SET latin1 NOT NULL,
  `icon` varchar(200) CHARACTER SET latin1 NOT NULL DEFAULT 'dummy.gif',
  `schoolid` int(11) DEFAULT NULL,
  `position` int(11) NOT NULL,
  `startdate` date DEFAULT NULL,
  `enddate` date DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=78 ;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `subject_has_competencies`
--

CREATE TABLE IF NOT EXISTS `subject_has_competencies` (
  `subjectid` int(11) DEFAULT NULL,
  `compid` int(11) DEFAULT NULL,
  KEY `subjectid` (`subjectid`,`compid`),
  KEY `compid` (`compid`),
  KEY `subjectid_2` (`subjectid`),
  KEY `subjectid_3` (`subjectid`,`compid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `subject_has_competency_for_space`
--

CREATE TABLE IF NOT EXISTS `subject_has_competency_for_space` (
  `subjectid` int(11) NOT NULL,
  `compid` int(11) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `subject_has_image`
--

CREATE TABLE IF NOT EXISTS `subject_has_image` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `icon` varchar(255) CHARACTER SET latin1 DEFAULT NULL,
  `fileSize` varchar(255) CHARACTER SET latin1 DEFAULT NULL,
  `webPath` varchar(255) CHARACTER SET latin1 DEFAULT NULL,
  `systemPath` varchar(255) CHARACTER SET latin1 DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=12 ;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `subject_has_levels`
--

CREATE TABLE IF NOT EXISTS `subject_has_levels` (
  `levelid` int(11) NOT NULL,
  `subjectid` int(11) NOT NULL,
  PRIMARY KEY (`levelid`,`subjectid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `subject_has_tools`
--

CREATE TABLE IF NOT EXISTS `subject_has_tools` (
  `subjectid` int(11) NOT NULL,
  `toolid` int(11) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `teacher_has_groups`
--

CREATE TABLE IF NOT EXISTS `teacher_has_groups` (
  `teacherid` int(11) NOT NULL,
  `groupid` int(11) NOT NULL,
  PRIMARY KEY (`teacherid`,`groupid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `teacher_has_subjects`
--

CREATE TABLE IF NOT EXISTS `teacher_has_subjects` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `teacherid` int(11) DEFAULT NULL,
  `subjectid` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=436 ;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `teacher_has_tools`
--

CREATE TABLE IF NOT EXISTS `teacher_has_tools` (
  `teacherid` int(11) NOT NULL,
  `toolid` int(11) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `user2test`
--

CREATE TABLE IF NOT EXISTS `user2test` (
  `ID` int(11) NOT NULL AUTO_INCREMENT,
  `IDuser` int(11) NOT NULL,
  `IDtest` int(11) NOT NULL,
  `userHash` varchar(128) NOT NULL,
  PRIMARY KEY (`ID`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=2701 ;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `user_has_tools`
--

CREATE TABLE IF NOT EXISTS `user_has_tools` (
  `studentid` int(11) NOT NULL,
  `teacherid` int(11) NOT NULL,
  `toolid` int(11) NOT NULL,
  `groupid` int(11) NOT NULL,
  `subjectid` int(11) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `user_tools`
--

CREATE TABLE IF NOT EXISTS `user_tools` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `url` varchar(255) NOT NULL,
  `icon` varchar(255) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=2 ;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `xapidata`
--

CREATE TABLE IF NOT EXISTS `xapidata` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `extstudent` text COLLATE utf8_unicode_ci NOT NULL,
  `activityid` int(11) NOT NULL,
  `raw` decimal(10,2) NOT NULL,
  `min` decimal(10,2) NOT NULL,
  `max` decimal(10,2) NOT NULL,
  `uniqueID` text COLLATE utf8_unicode_ci NOT NULL,
  `timestamp` text COLLATE utf8_unicode_ci NOT NULL,
  `scaledval` decimal(10,2) NOT NULL,
  `status` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=24 ;

/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
