<?php
    require '../Slim/Slim.php';
    require 'databasebackend.php';
    ini_set('display_errors',1);
    ini_set('display_startup_errors',1);
    error_reporting(E_ALL);
    //header("Content-type: application/json; charset=utf-8");
    
    $app = new Slim(array(
        'debug' => true,
        'log.level' => Slim_Log::ERROR
    ));
    
    //$app->contentType('application/json;charset=utf-8');
    $app->add(new Slim_Middleware_ContentTypes());
    $response = $app->response();
    $response->header('Content-type', 'application/json;charset=utf-8');
    $response->header('Access-Control-Allow-Origin', '*');
    $response->header('Access-Control-Allow-Methods', 'POST, GET, PUT');

    // route middleware for simple API authentication

    //helper function, checks if the user is authenticated
    // to use this function simply add the 'authenticate' in the call
    //and it will not proceed with execution if this function returns false
    function authenticate(){
        $app = Slim::getInstance();
        $userid = $app->getEncryptedCookie('userid'); // is there a session with userid
        //echo "$userid";
        //if not thrn return a not authnticated message and quit execution, if yes the simply proceed
        if (!$userid) {
            encodeResponse("User is not loged in!", false);
            //$app->halt(401);
            exit;
        }
    }

    //check if the user is authenticated
    $app->get('/authenticated', 'authenticate', function () use ($app){
        encodeResponse("User is loged in!");
    });

    // logs out the user by deleting the session
    $app->get('/logout', function () use ($app){
        $app->deleteCookie('userid');
        $app->deleteCookie('schoolid');
        $app->deleteCookie('role');
        encodeResponse("Succesfully loged out!");
    });

    // authenticates the user and saves the user id in session
    $app->post('/login', function () use ($app){
        $db = new DatabaseBackend();
        $params = $app->request()->params();
        $userid = $params['userid'];
        $password = $params['password'];
        $userid = stripslashes($userid);
        $password = stripslashes($password);
        // does the user with userid, password and the role 3 exis in database
        $result = $db->login($userid, $password, 3);
        if(!$result){
            // if not does the user with userid, password and the role 1 exis in database
            $result = $db->login($userid, $password, 1);

        }
        // if yes se the session into encrypted cookie
        if($result) {
            //encodeResponse($result);
            $app->setEncryptedCookie('userid', $result["id"], time()+24*3600); //expires in 24 hours
            //$app->setEncryptedCookie('groups', $result["groups"], time()+24*3600);
            $app->setEncryptedCookie('schoolid', $result["schoolid"], time()+24*3600);
            //$app->setEncryptedCookie('role', $result["role"], time()+24*3600);

            encodeResponse("Succesfully logged in!");
        } else {// if no return error message
            encodeResponse("The username or password is incorrect!", false);
        }
    });
 
    /*
    $app->get('/login', function () use ($app)  {
        $app->setEncryptedCookie('uid', 'demo', '5 minutes');
        echo "OK";
    });
    */
    
    //test call
    $app->get('/test_login', 'authenticate', function () use ($app)  { 
        echo $app->getEncryptedCookie('userid');
    });

    //test call
    $app->get('/', function () {
        echo "it works!";
    });

    //test call
    $app->post('/ping', function () use ($app) {
        $params = $app->request()->params();
        encodeResponse($params);
    });

    //test call
    $app->get('/test', function () {
        echo "it works!";
    });

    //returns a group for a teacher id that is saved in session
    $app->get('/groups', 'authenticate', function() use ($app) {
        //$groups = $app->getEncryptedCookie('groups');
        $teacherId = $app->getEncryptedCookie('userid');

        $db = new DatabaseBackend();
        $data = $db->getGroupsByTeacherId($teacherId);
        encodeResponse($data);
    });

    //returns a list of all subjects for the teacher id (in session)
    $app->get('/subjects', 'authenticate', function() use ($app) {
        //$subjects = $app->getEncryptedCookie('subjects');
        $teacherId = $app->getEncryptedCookie('userid');

        $db = new DatabaseBackend();
        $data = $db->getSubjectsByTeacherId($teacherId);
        encodeResponse($data);
    });

    $app->get('/subjectsforgroup/:id', 'authenticate', function($id) use ($app) {
        //$subjects = $app->getEncryptedCookie('subjects');
        $teacherId = $app->getEncryptedCookie('userid');

        $db = new DatabaseBackend();
        $data = $db->getSubjectsByTeacherIdAndGroup($teacherId, $id);
        encodeResponse($data);
    });

    //returns a dependency for the teacher id that is saved in session
    $app->get('/studentsforgroup/:id', function($id) use ($app)  {
        $db = new DatabaseBackend();
        $group = $db->getGroup($id);
        $data = $db-> getStudentsByGroupId($id);
        encodeResponse($data);
        

        //$data = $db->getStudentByGroupId($id);
       //encodeResponse($data);
    });
    //******************************************************************
    
    $app->get('/groupreports/:selectedGroupId/:selctedMindmapId', function($selectedGroupId, $selctedMindmapId) use ($app) {
        $db = new DatabaseBackend();
        $group = $db->getGroup($selectedGroupId);

        if (count($group) ==0){
            encodeResponse("Group deos not exist!", false);
        }else{
            $members = $group[0]["members"];

            $sdutendtIds = splitToArray($members);
            $data = $db->getReports($selctedMindmapId, $sdutendtIds);
            encodeResponse($data);
        }
    });
    //*******************************************************************

    $app->get('/increaseStudentActivity/:studentId/:activityId/:groupId/:mindmapId', function($studentId, $activityId, $groupId, $mindmapId) use($app){
        $db = new DatabaseBackend();
        $teacherId = $app->getEncryptedCookie('userid');
        $value = 1;
        $mindmapId = intval($mindmapId);
        $data = $db->insertActivityLog($studentId, $activityId, $groupId, $teacherId, $mindmapId, $value);
        encodeResponse($data);
    });

    $app->get('/decreaseStudentActivity/:studentId/:activityId/:groupId/:mindmapId', function($studentId, $activityId, $groupId, $mindmapId) use($app){
        $db = new DatabaseBackend();
        $teacherId = $app->getEncryptedCookie('userid');
        $value = -1;
        $mindmapId = intval($mindmapId);
        $data = $db->insertActivityLog($studentId, $activityId, $groupId, $teacherId, $mindmapId, $value);
        encodeResponse($data);
    });


/*
    $app->get('/studentactivities/:studentid/:groupId', function($studentid, $groupId) use($app) {
        $db = new DatabaseBackend();
        $teacherId = $app->getEncryptedCookie('userid');

        $group = $db->getGroup($groupId);
        $group = $group[0];
        //print_r($group);
        //return;
        
        $activites = splitToArray($group["activities"], "-");

        $data = $db->getStudentsActivities($studentid, $teacherId, $activites);
        encodeResponse($data);
    });
*/
    $app->get('/studentactivities/:studentid/:groupId/:subjectId', function($studentid, $groupId, $subjectId) use($app){
        $db = new DatabaseBackend();
        $teacherId = $app->getEncryptedCookie('userid');

        $group = $db->getGroup($groupId);
        $group = $group[0];
        //$subjects = $db->getSubject($subjectId);
        //$activities = $db->getActivities($studentid, $teacherId, $activities);

        $data = $db->getStudentsActivities($studentid, $teacherId, $subjectId);
        encodeResponse($data);
    });

    /*
    $app->get('/studentactivities/:studentid', function ($studentid) use ($app){
        $db = new DatabaseBackend();
        $teacherId = $app->getEncryptedCookie('userid');
        $data = $db->getStudentsActivities($studentid, $teacherId);
        encodeResponse($data);

    });
    */
    $app->get('/competenciesformindmap/:id/:studentid', function($id, $studentid) use($app) {
        $db = new DatabaseBackend();
        $data = $db->getMindMapCompetenciesByIdForStudent($id, $studentid);
        //print_r($data);
        $competencies = array();
        foreach ($data as $key => $value) {
            $cid = $value["cid"];
            if(!array_key_exists($cid, $competencies)){
               $competence = array('id' => $value["cid"], 'name' => $value["cname"], 'evidences'=>array());
               $competencies[$cid] = $competence;
            }
            if($value["eid"]){
                $evidence = array('id' => $value["eid"], 'name' => $value["ename"], 'value' => $value["value"]);
                $competencies[$cid]['evidences'][] = $evidence;
            }
        }
        encodeResponse($competencies);
    });

    $app->post('/studentevidence', function() use ($app) {
        //$data = $db->getStudentEvidencesByValue($id, $eid, $value)
        $db = new DatabaseBackend();
        $params = $app->request()->params();
        
        $studentid = $params['studentid'];
        $evidence = $params['evidence'];
        $value = $params['value'];
        
        $result = $db->insertUpdateStudentsEvidences($studentid, $evidence, $value);
        
        encodeResponse($result);
    });

    $app->get('/mindmap', 'authenticate', function () use ($app){
        $teacherId = $app->getEncryptedCookie('userid');
        $db = new DatabaseBackend();
        $data = $db->getCharts($teacherId);
    
        encodeResponse($data);
    });

    $app->get('/mindmapforgroupsandsubjects/:groupId/:subjectId', 'authenticate', function ($groupId, $subjectId) use ($app){
        $teacherId = $app->getEncryptedCookie('userid');
        $db = new DatabaseBackend();
        #$data = $db->getCharts($teacherId);
        $data = $db->getChartsByGroupAndSubject($teacherId,$groupId, $subjectId);
        encodeResponse($data);
    });

    

    $app->get('/mindmap/:id', 'authenticate', function ($id) use ($app){
        $db = new DatabaseBackend();
        $data = $db->getChartsById($id);
        encodeResponse($data);
    });

    //Copy mindmap for particular teacher
    $app->get('/copymindmap/:teacherId', 'authenticate', function ($teacherId) use ($app){
        //echo "copymindmap";
        //echo $teacherId;
        $id = 24;
        $db = new DatabaseBackend();
        $data = $db->getChartsById($id);
        $name = $data[0]['name'];
        $minddata = utf8_decode($data[0]['data']);
        //echo $name;
        //echo print_r($minddata);
        $result = $db->addChart($teacherId, $name, $minddata);
        if($result){
                encodeResponse(array("id" => $result, "mssage" => "Record added!"));
            } else {
                encodeResponse("Reecord could not be added!", false);
            };

        //print_r($data[0]);
    });

     //Add Settings 
    $app->post('/mindmap', 'authenticate', function() use ($app) {
        $teacherId = $app->getEncryptedCookie('userid');

        $db = new DatabaseBackend();
        $params = $app->request()->params();
        $name = $params['name'];
        $data = $params['data'];  
        $id = $params['id'];
        $subjectId = $params['subject'];
        $groupId = $params['group'];
        //$subjectid = $params['subjectid'];
        

        if(intval($id) > 0){
            $result = $db->updateChart($id, $teacherId, $name, $data, $groupId, $subjectId);

            if($result){
                encodeResponse("Record updated!");
            } else {
                encodeResponse("Record could not be updated!", false);
            };
        } else {
            $result = $db->addChart($teacherId, $name, $data, $groupId, $subjectId);
            if($result){
                encodeResponse(array("id" => $result, "mssage" => "Record added!"));
            } else {
                encodeResponse("Reecord could not be added!", false);
            };
        }
    });

    //Delete Chart
     $app->post('/delete_chart', 'authenticate', function () use ($app) {
        $db = new DatabaseBackend();
        $params = $app->request()->params();
        $id = $params['id'];
        $result = $db->deleteChart($id);
        if($result == 1){
            return $result;
        }else{
            echo "Record could not be deleted!";
        };
    }); 

    //Requests for mindmap END

    function encodeResponse($data, $success = true){
        $result = array("success" => $success, "content" => $data);
        echo json_encode(utf8_decode_all($result));
    }

    function splitToArray($text, $delimiter="-"){
        $splitedText = explode($delimiter, $text);
        foreach ($splitedText as $key => $value) {
            if($value == ""){
                unset($splitedText[$key]);
            }
        }
        return $splitedText;
    }

    function utf8_encode_all($dat) // -- It returns $dat encoded to UTF8 
    { 
      if (is_string($dat)) return utf8_encode($dat); 
      if (!is_array($dat)) return $dat; 
      $ret = array(); 
      foreach($dat as $i=>$d) $ret[$i] = utf8_encode_all($d); 
      return $ret; 
    } 

    function utf8_decode_all($dat) // -- It returns $dat decoded from UTF8 
    { 
      if (is_string($dat)) return utf8_decode($dat); 
      if (!is_array($dat)) return $dat; 
      $ret = array(); 
      foreach($dat as $i=>$d) $ret[$i] = utf8_decode_all($d); 
      return $ret; 
    } 

    
    $app->run();
?>
