<?php
session_start();
if (isset($_SESSION['uName'])) {
    ?>
    <!DOCTYPE html>
    <html>
        <head>
            <meta charset="utf-8">
            <link rel="shortcut icon" type="image/ico" href="">
            <meta name="viewport" content="initial-scale=1.0, maximum-scale=2.0">

            <title>Activity - ConfigTool</title>
            <link rel="stylesheet" type="text/css" href="../css/bootstrap.css">
            <link rel="stylesheet" type="text/css" href="../css/jquery.dataTables.css">
            <link rel="stylesheet" type="text/css" href="../css/dataTables.tableTools.css">
            <link rel="stylesheet" type="text/css" href="../css/dataTables.editor.css">
            <link rel="stylesheet" type="text/css" href="../css/editor.upload.css">
            <link rel="stylesheet" type="text/css" href="../css/font-awesome.css">

            <style type="text/css" class="init">

                table.dataTable tr td:first-child {
                    text-align: center;
                }

                table.dataTable tr td:first-child:before {
                    content: "\f096"; /* fa-square-o */
                    font-family: FontAwesome;
                }

                table.dataTable tr.selected td:first-child:before {
                    content: "\f046"; /* fa-check-square-o */
                }

                table.dataTable tr td.dataTables_empty:first-child:before {
                    content: "";
                }

            </style>

            <script type="text/javascript" language="javascript" src="../js/jquery.js"></script>
            <script type="text/javascript" language="javascript" src="../js/jquery.dataTables.min.js"></script>
            <script type="text/javascript" language="javascript" src="../js/dataTables.tableTools.min.js"></script>
            <script type="text/javascript" language="javascript" src="../js/dataTables.editor.min.js"></script>
            <script type="text/javascript" language="javascript" src="../js/editor.upload.js"></script>
            <script type="text/javascript" language="javascript" class="init">



                var editor; // use a global for the submit and return data rendering in the examples

                $(document).ready(function () {
                    editor = new $.fn.dataTable.Editor({
                        ajax: "../inculdes/activities.php",
                        table: "#example",
                        fields: [{
                                label: "Name:",
                                name: "activities.name"
                            },
                            {
                                label: "Position:",
                                name: "activities.position"
                            },
                            {
                                label: "Activity Influence:",
                                name: "activities.activityinfluence"
                            },
                            {
                                "label": "Icon:",
                                "name": "activities.icon",
                                "type": "upload",
                                "display": function (val, row) {
                                    return val && row.activity_has_images.webPath ?
                                            '<img src="' + row.activity_has_images.webPath + '"/>' :
                                            'No image';
                                }
                            },
                                {
                                "label": "Competencies",
                                "name": "competencies[].id",
                                "type": "checkbox"
                            },
//                                {
//                                "label": "Teachers:",
//                                "name": "people[].id",
//                                "type": "checkbox"
//                            }, 
                                {
                                "label": "Subjects",
                                "name": "subjects[].id",
                                "type": "checkbox"
                            }
                        ]
                    });

                    // Activate an inline edit on click of a table cell
                    $('#example').on('click', 'tbody td:not(:first-child)', function (e) {
                        editor.inline(this, {
                            submitOnBlur: true
                        });
                    });

                    //function used to send olm data call after database insertion 
                    editor.on('postSubmit', function (e, json, data, action) {

                        console.info(data);
                        var operation = action
                        var userinfo = '';
                        if (operation == "remove") {
                            userinfo = data;
                        } else {
                            userinfo = json;
                        }
                        jQuery.ajax({
                            type: 'POST',
                            data: userinfo,
                            url: '../inculdes/OlmActivityOperations.php?action=' + operation,
                            error: function (result, transport) {
                                alert("Sorry, the operation is failed.");
                            },
                            success: function (result) {
                                console.info(result);
                            }
                        });
                    });

                    $('#example').dataTable({
                        dom: "Tfrtip",
                        ajax: {
                            url: "../inculdes/activities.php",
                            type: 'POST'
                        },
                        columns: [
                            {data: null, defaultContent: '', orderable: false},
                            {data: "activities.name"},
                            {data: "people", render: "[, ].userid"},
                            {data: "subjects", render: "[, ].name"},
                            {data: "competencies", render: "[, ].name"},
                            {
                                "data": "activity_has_images",
                                "defaultContent": "No image",
                                "render": function (d) {
                                    return d.webPath ?
                                            '<img src="' + d.webPath + '" width="60" height="60"/>' :
                                            null;
                                }
                            }
                        ],
                        tableTools: {
                            sRowSelect: "os",
                            sRowSelector: 'td:first-child',
                            aButtons: [
                                {sExtends: "editor_create", editor: editor},
                                {sExtends: "editor_edit", editor: editor},
                                {sExtends: "editor_remove", editor: editor}
                            ]
                        }
                    });
                });



            </script>
        </head>

        <body class="dt-example">
            <div class="container">
                <div class="row">
                    <div class="nav" role="navigation">
                        <div class="container">
                            <div class="navbar-header">
                                <a class="navbar-brand" href="../"><img src="../../images/ic_home.png" width="43" height="22" border="0"></a>
                                <a class="navbar-brand" href="../../logout.php" title="logout"><img src="../../images/logout.png" title="logout" width="30" height="30" border="0"></a>
                            </div>

                        </div>
                    </div>
                    <br/>
                    <section>
                        <h1>Activities</h1>
                        <table id="example" class="display" cellspacing="0" width="100%">
                            <thead>
                                <tr>
                                    <th>
                                    <th>Group Name</th>
                                        <th>Members</th>
                                    <th>Subjects</th>
                                    <th>Competencies</th>
                                    <th>Icon</th>
                                </tr>
                            </thead>
                        </table>
                    </section>
                    <footer>
                        <div class="col-lg-12 seprater" >

                        </div> 
                        <p>
                            &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 
                            &copy; 2014 TU Graz [v3.01 MTO Version]
                        </p>
                    </footer>
                </div>
            </div>

        </body>
    </html>
    <?php
} else {
    header('Location:../');
}
