<?php
session_start();
if (isset($_SESSION['uName'])) {
    ?>

    <!DOCTYPE html>
    <html>
        <head>
            <meta charset="utf-8">
            <link rel="shortcut icon" type="image/ico" href="">
            <meta name="viewport" content="initial-scale=1.0, maximum-scale=2.0">

            <title>Competencies - ConfigTool</title>
            <link rel="stylesheet" type="text/css" href="../css/bootstrap.css">
            <link rel="stylesheet" type="text/css" href="../css/jquery.dataTables.css">
            <link rel="stylesheet" type="text/css" href="../css/dataTables.tableTools.css">
            <link rel="stylesheet" type="text/css" href="../css/dataTables.editor.css">
            <link rel="stylesheet" type="text/css" href="../css/editor.upload.css">
            <link rel="stylesheet" type="text/css" href="../css/font-awesome.css">

            <style type="text/css" class="init">

                table.dataTable tr td:first-child {
                    text-align: center;
                }

                table.dataTable tr td:first-child:before {
                    content: "\f096"; /* fa-square-o */
                    font-family: FontAwesome;
                }

                table.dataTable tr.selected td:first-child:before {
                    content: "\f046"; /* fa-check-square-o */
                }

                table.dataTable tr td.dataTables_empty:first-child:before {
                    content: "";
                }

            </style>

            <script type="text/javascript" language="javascript" src="../js/jquery.js"></script>
            <script type="text/javascript" language="javascript" src="../js/jquery.dataTables.min.js"></script>
            <script type="text/javascript" language="javascript" src="../js/dataTables.tableTools.min.js"></script>
            <script type="text/javascript" language="javascript" src="../js/dataTables.editor.min.js"></script>
            <script type="text/javascript" language="javascript" src="../js/editor.upload.js"></script>
            <script type="text/javascript" language="javascript" class="init">



                var editor; // use a global for the submit and return data rendering in the examples

                $(document).ready(function () {

                    editor = new $.fn.dataTable.Editor({
                        ajax: "../inculdes/competencies.php",
                        table: "#example",
                        fields: [{
                                label: "Name:",
                                name: "competencies.name"
                            }, {
                                label: "Description",
                                name: "competencies.description",
                                type: "textarea"
                            }, {
                                label: "Prerequisites",
                                name: "competencies.prerequisites"
                            }, {
                                label: "Position",
                                name: "competencies.childlevel"
                            },
                            {
                                label: "Competency Influence",
                                name: "competencies.competencyinfluence"
                            },
                            {
                                label: "Parentid",
                                name: "competencies.parentid"
                            },
    //                            {
    //                                label: "Value",
    //                                name: "competencies.value"
    //                            }, {
    //                                label: "Weight",
    //                                name: "competencies.weight"
    //                            }, 
                            {
                                label: "Levels",
                                name: "levels[].id",
                                type: "checkbox"
                            },
    //                            {
    //                                label: "Olm DataSource",
    //                                name: "competencies.datasourceid",
    //                                type: "select"
    //                            }, {
    //                                label: "Olm Group",
    //                                name: "groups[].id",
    //                                type: "checkbox"
    //                            },
                            {
                                label: "Subjects",
                                name: "subjects[].id",
                                type: "checkbox"
                            }
                        ],
                        i18n: {
                            create: {
                                title: "Create New Competency",
                                submit: "Save"
                            },
                            edit: {
                                title: "Edit Competency",
                                submit: "Update"
                            }
                        }
                    });

                    // Activate an inline edit on click of a table cell
                    editor.on('preSubmit', function (e, data, action) {

                        console.info(data);
                        var operation = action
                        var userinfo = '';
                        if (operation == "remove") {
                            userinfo = data;
                        }
    //                    jQuery.ajax({
    //                        type: 'POST',
    //                        data: userinfo,
    //                        url: '../inculdes/OlmCompetencyOperations.php?action=' + operation,
    //                        error: function(result, transport) {
    //                            alert("Sorry, the operation is failed.");
    //                        },
    //                        success: function(result) {
    //                            console.info(result);
    //                        }
    //                    });
                    });

                    //function used to send olm data call after database insertion 
                    editor.on('postSubmit', function (e, json, data, action) {

                        console.info(data);
                        var operation = action
                        var userinfo = '';
                        if (operation == "remove") {
                            userinfo = data;
                        } else {
                            userinfo = json;
                        }
                        jQuery.ajax({
                            type: 'POST',
                            data: userinfo,
                            url: '../inculdes/OlmCompetencyOperations.php?action=' + operation,
                            error: function (result, transport) {
                                alert("Sorry, the operation is failed.");
                            },
                            success: function (result) {
                                console.info(result);
                            }
                        });
                    });


                    $('#example').dataTable({
                        dom: "Tfrtip",
                        ajax: {
                            url: "../inculdes/competencies.php",
                            type: 'POST'
                        },
                        columns: [
                            {data: null, defaultContent: '', orderable: false},
                            {data: "competencies.id"},
                            {data: "competencies.name"},
                            {data: "subjects", render: "[, ].name"},
                            {data: "competencies.parentid"},
                            {data: "competencies.description"},
                            {data: "levels", render: "[, ].name"}
                        ],
                        tableTools: {
                            sRowSelect: "os",
                            sRowSelector: 'td:first-child',
                            "sSwfPath": "../TableTools-2.2.4/swf/copy_csv_xls_pdf.swf",
                            aButtons: [
                                {sExtends: "editor_create", editor: editor},
                                {sExtends: "editor_edit", editor: editor},
                                {sExtends: "editor_remove", editor: editor},
                                 {sExtends: 'collection',"sButtonText": "Export Data", editor: editor,aButtons: ['copy','csv','pdf','print', 'xls']}

                            ]
                        }
                    });
                });



            </script>
        </head>

        <body class="dt-example">
            <div class="container">
                <div class="row">
<!--                    <div class="nav" role="navigation">
                        <div class="container">
                            <div class="navbar-header">
                                <a class="navbar-brand" href="../"><img src="../../images/ic_home.png" width="43" height="22" border="0"></a>
                                <a class="navbar-brand" href="../../logout.php" title="logout"><img src="../../images/logout.png" title="logout" width="30" height="30" border="0"></a>
                            </div>

                        </div>
                    </div>-->

                    <div class="navbar-header">
                        <a class="navbar-brand" href="../"><img src="../../images/images.jpg" width="43" height="40" border="0"></a>
                    </div>
                    <br>
                    <br/>
                    <section>
                        <h1>Competencies</h1>
                        <?php
                        if (isset($_GET['action'])) {
                            if ($_GET['action'] == 'csvupload') {
                                include("csvupload.php");
                            }
                        } else {
                            ?>

                        <a href='?action=csvupload' class='btn btn-success btn-sm' title='Add Competency through Batch processing' style="margin-bottom:10px">CSV UPLOAD</a>


                            <table id="example" class="display" cellspacing="0" width="100%">
                                <thead>
                                    <tr>
                                        <th></th>
                                        <th>ID</th>
                                        <th>Name</th>
                                        <th>Subjects</th>
                                        <th>ParentID</th>

                                        <th>Description</th>
                                        <th>Levels</th>
                                    </tr>
                                </thead>

                            </table>
                        <?php } ?>
                    </section>
                    <footer>
                        <div class="col-lg-12 seprater" >

                        </div> 
                        <p>
                            &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 
                            &copy; 2014 TU Graz [v3.01 MTO Version]
                        </p>
                    </footer>
                </div>
            </div>

        </body>
    </html>

    <?php
} else {
    header('Location:../');
}