<?php
session_start();

if (!isset($_SESSION['uName'])) {
    header('Location:../../');
}
// DataTables PHP library
include( "../../php/DataTables.php" );

// Alias Editor classes so they are easy to use
use
	DataTables\Editor,
	DataTables\Editor\Field,
	DataTables\Editor\Format,
	DataTables\Editor\Join,
	DataTables\Editor\Upload,
	DataTables\Editor\Validate;


/*
 * Example PHP implementation used for the join.html example
 */
Editor::inst( $db, 'activities' )
	->field( 
                Field::inst( 'activities.id' ),
		Field::inst( 'activities.name')->validator( 'Validate::unique', array(
                                            'required'=>true,
                                            'message'=>'This field is required and must be unique.')),
                Field::inst( 'activities.activityinfluence' ),
                Field::inst( 'activities.position'),
                Field::inst( 'activities.subject'),
                Field::inst( 'activities.icon' )
                ->upload(
                    Upload::inst( $_SERVER['DOCUMENT_ROOT'].'/mkrwww/leas-portal/configtool_beta/dashboard/upload/activity/__ID__.__EXTN__' )
                        ->db( 'activity_has_images', 'id', array(
                            'icon' => Upload::DB_FILE_NAME,
                            'fileSize' => Upload::DB_FILE_SIZE,
                            'webPath' => Upload::DB_WEB_PATH,
                            'systemPath'  => Upload::DB_SYSTEM_PATH
                        ) )
                ),
                Field::inst( 'activity_has_images.icon' ),
                Field::inst( 'activity_has_images.webPath' ),
                Field::inst( 'activities.schoolid' )
                        ->setValue($_SESSION['schoolid'])
	)
        ->join(
            Join::inst( 'people', 'array' )
                ->join(
                    array( 'id', 'activityid' ),
                    array( 'id', 'teacherid' ),
                    'activities_has_teachers'
                )
                ->fields(
                    Field::inst( 'id' )
                        ->options(
                                    function () use ($db) {
                                        // Use `selectDistinct` to get the full list of names from the
                                        // database and then concatenate the first and last names
                                        $userList = $db->selectDistinct( 'people', 'id, firstname,surname, role,schoolid', null, 'firstname ASC' );
                                        $out = array();

                                        while ( $row = $userList->fetch() ) {
                                            if($row['role']== '1' && $row['schoolid']==$_SESSION['schoolid'] && $row['id']!=$_SESSION['userid']){
                                                $out[] = array(
                                                    "value" => $row['id'],
                                                    "label" => $row['firstname'].' '.$row['surname']
                                                );
                                            }
                                        }

                                        return $out;
                                    }
                                ),
                    Field::inst( 'userid' )
                ),
            Join::inst( 'subjects', 'array' )
                ->join(
                    array( 'id', 'activityid' ),
                    array( 'id', 'subjectid' ),
                    'activities_has_subjects'
                )
                ->fields(
                    Field::inst( 'id' )
                        ->options(
                                function () use ($db) {
                                    // Use `selectDistinct` to get the full list of names from the
                                    // database and then concatenate the first and last names
                                    $userList = $db->selectDistinct( 'subjects', 'id, name,schoolid', null, 'name ASC' );
                                    $out = array();
//                                    $out[] = array(
//                                                "value" => '',
//                                                "label" => 'Select Subject'
//                                            );

                                    while ( $row = $userList->fetch() ) {
                                        if($row['schoolid']==$_SESSION['schoolid']){
                                            $out[] = array(
                                                "value" => $row['id'],
                                                "label" => $row['name']
                                            );
                                        }
                                    }

                                    return $out;
                                }
                                ),
                    Field::inst( 'name' )
                ),
                                        // show competency with join
                                        Join::inst('competencies', 'array')
                ->join(
                        array('id', 'activityid'), array('id', 'competenceid'), 'activities_has_competencies'
                )
                ->fields(
                        Field::inst('id')
                        ->options(
                                function () use ($db) {
                            // Use `selectDistinct` to get the full list of names from the
                            // database and then concatenate the first and last names
                            $userList = $db->selectDistinct('competencies', 'id, name,schoolid', null, 'name ASC');
                            $out = array();

                            while ($row = $userList->fetch()) {
                                if ($row['schoolid'] == $_SESSION['schoolid']) {
                                    $out[] = array(
                                        "value" => $row['id'],
                                        "label" => $row['name']
                                    );
                                }
                            }
                            return $out;
                        }
                        ), Field::inst('name')
                ) //end compt loop
        )
        ->leftJoin( 'activity_has_images', 'activity_has_images.id', '=', 'activities.icon' )
        ->where('activities.schoolid',$_SESSION['schoolid'])
	->process($_POST)
	->json();
