<?php

session_start();

if (!isset($_SESSION['uName'])) {
    header('Location:../../');
}
// DataTables PHP library
include( "../../php/DataTables.php" );

// Alias Editor classes so they are easy to use
use DataTables\Editor,
    DataTables\Editor\Field,
    DataTables\Editor\Format,
    DataTables\Editor\Join,
    DataTables\Editor\Upload,
    DataTables\Editor\Validate;

/*
 * Example PHP implementation used for the join.html example
 */
Editor::inst($db, 'subjects')
        ->field(
                Field::inst('subjects.name')->validator('Validate::notEmpty'),
                Field::inst('subjects.icon')
                ->upload(
                        Upload::inst($_SERVER['DOCUMENT_ROOT'] . '/mkrwww/leas-portal2/configtool_beta/dashboard/upload/subjects/__ID__.__EXTN__')
                        ->db('subject_has_image', 'id', array(
                            'icon' => Upload::DB_FILE_NAME,
                            'fileSize' => Upload::DB_FILE_SIZE,
                            'webPath' => Upload::DB_WEB_PATH,
                            'systemPath' => Upload::DB_SYSTEM_PATH
                        ))
                ), Field::inst('subject_has_image.icon'), Field::inst('subject_has_image.webPath'), Field::inst('subjects.schoolid')
                ->setValue($_SESSION['schoolid'])
        )
        ->join(
                Join::inst('levels', 'array')
                ->join(
                        array('id', 'subjectid'), array('id', 'levelid'), 'subject_has_levels'
                )
                ->fields(
                        Field::inst('id')
                        ->options(
                                function () use ($db) {
                            // Use `selectDistinct` to get the full list of names from the
                            // database and then concatenate the first and last names
                            $userList = $db->selectDistinct('levels', 'id, name,schoolid', null, 'name ASC');
                            $out = array();

                            while ($row = $userList->fetch()) {
                                if ($row['schoolid'] == $_SESSION['schoolid']) {
                                    $out[] = array(
                                        "value" => $row['id'],
                                        "label" => $row['name']
                                    );
                                }
                            }
                            return $out;
                        }
                        ), Field::inst('name')
                ), Join::inst('competencies', 'array')
                ->join(
                        array('id', 'subjectid'), array('id', 'compid'), 'subject_has_competencies'
                )
                ->fields(
                        Field::inst('id')
                        ->options(
                                function () use ($db) {
                            // Use `selectDistinct` to get the full list of names from the
                            // database and then concatenate the first and last names
                            $userList = $db->selectDistinct('competencies', 'id, name,schoolid', null, 'name ASC');
                            $out = array();

                            while ($row = $userList->fetch()) {
                                if ($row['schoolid'] == $_SESSION['schoolid']) {
                                    $out[] = array(
                                        "value" => $row['id'],
                                        "label" => $row['name']
                                    );
                                }
                            }
                            return $out;
                        }
                        ), Field::inst('name')
                ),
                                 Join::inst('mytools', 'array')
                ->join(
                        array('id', 'subjectid'), array('id', 'toolid'), 'subject_has_tools'
                )
                ->fields(
                        Field::inst('id')
                        ->options(
                                function () use ($db) {
                            // Use `selectDistinct` to get the full list of names from the
                            // database and then concatenate the first and last names
                            $userList = $db->selectDistinct('mytools', 'id, name', null, 'name desc');
                            $out = array();

                            while ($row = $userList->fetch()) {
                                    $out[] = array(
                                        "value" => $row['id'],
                                        "label" => $row['name']
                                    );
                                
                            }

                            return $out;
                        }
                        ), Field::inst('name')
                )
        )
        ->leftJoin('subject_has_image', 'subject_has_image.id', '=', 'subjects.icon')
        ->where('subjects.schoolid', $_SESSION['schoolid'])
        ->process($_POST)
        ->json();
