<?php
require 'database.php';

class DatabaseBackend extends Database{
	public function  __construct(){
		parent::__construct("localhost", "myclass3_lea", "root", "csskti$$1154");
	}

	public function login($userid, $password, $role = NULL) {
		//$userid = $mysqli->real_escape_string($userid);
        //$password = $mysqli->real_escape_string($password);
        $sql = "";
        
        if($role){
        	$sql = "SELECT * FROM people WHERE userid = '$userid' AND password='$password' AND role=$role";  // roli qetu duhet mu hjek besoj
        }else{
        	$sql = "SELECT * FROM people WHERE userid = '$userid' AND password='$password'";
        }
        
        $result = $this->getResultsQuery($sql);

        if (count($result) > 0 ) {
        	return $result[0];
        } else {
      		return 0;
        }
	}   


	public function getGroup($id){
		$sql = "SELECT * FROM groups WHERE id = $id";
		return $this->getResultsQuery($sql);
	}

	public function getGroups(){
		$sql = "SELECT * FROM groups";

		return $this->getResultsQuery($sql);
	}

	public function getGroupsByIds($ids){
		$strIds = implode(",", $ids);

		$sql = "SELECT * 
				FROM groups 
				WHERE id IN ($strIds)";
		return $this->getResultsQuery($sql);
	}

	public function getStudentByIds($ids){
		$strIds = implode(",", $ids);

		$sql = "SELECT 
					id, 
					icon,
					firstname
				FROM people 
				WHERE id IN ($strIds)";
		return $this->getResultsQuery($sql);
	}

	public function getStudentByGroupId($id){
		$sql = "SELECT
					id, 
					icon,
					firstname
				FROM people
				WHERE role = 2 AND groups LIKE '%-".$id."-%' " ;
		return $this->getResultsQuery($sql);
	}
//***********************************************************
	public function getReports($mindmapId, $studentids){
		$strIds = implode(",", $studentids);

		$sql = "SELECT COUNT(distinct ME.id) as count
				FROM mindmapcompetencies MC
				INNER JOIN mindmapevidences ME
					ON ME.competenceid = MC.id
				WHERE mindmapid = $mindmapId  
				";

		$countRow = $this->getResultsQuery($sql);
		$count = $countRow[0]["count"];
		if($count < 1) $count = 1;

		$sql = "SELECT  
						#MC.id AS cid,
						#MC.name AS cname,
						#ME.id AS eid,
						#ME.name AS ename,
						#ME.priority AS priority,
						#IFNULL(SE.value, 0) as value,
						P.id,
				        P.firstname,
				        P.surname,
						ROUND(100.0*IFNULL(SUM(SE.value),0)/$count, 1) as percentage
				FROM mindmapcompetencies MC
				LEFT JOIN mindmapevidences ME
					ON ME.competenceid = MC.id AND mindmapid = $mindmapId
				INNER JOIN studentevidences SE 
					ON SE.evidence = ME.name
				RIGHT JOIN people P
					ON P.id = SE.studentid
				WHERE P.id IN ($strIds)
				GROUP BY P.id";
		return $this->getResultsQuery($sql);
	}
//***************************************************************
	public function getStudentsActivities($studentID, $teacherID, $activities){
		$strActivities = implode(",", $activities);

		$sql = "SELECT
					A.id,
					A.name, 
				    A.icon, 
				    #L.groupid, 
				    #L.teacherid, 
				    #L.studentid,
				    IFNULL(SUM(L.value), 0) as value
				FROM activities A
				LEFT JOIN activitieslog L
				ON A.id = L.activityid 
					AND studentid=$studentID
					AND teacherid=$teacherID
				WHERE A.id IN ($strActivities)
				GROUP BY A.id";

		return $this->getResultsQuery($sql);
	}
	//WHERE userid = $teacherID
	public function insertActivityLog($studentId, $activityId, $groupId, $teacherId, $mindmapId, $value){
		$sql = "INSERT INTO activitieslog (id, activityid, mindmapid, groupid, teacherid, value, studentid) 
				VALUES (NULL, $activityId, $mindmapId, $groupId, $teacherId, $value, $studentId)";
		return $this->executeInsertQuery($sql);
	}

	/*public function getMindMapCompetenciesById($id){
		$sql = "SELECT * FROM relmindmapcompetencies RMC
				INNER JOIN mindmapcompetencies MC 
				ON MC.id = RMC.competenceid
				WHERE RMC.mindmapid = " .$id ;
		return $this->getResultsQuery($sql);
	}*/

	/*public function getMindMapCompetenciesById($id){
		$sql = "SELECT MC.id AS cid, ME.id AS eid, ME.name AS ename, MC.name AS cname
				FROM mindmapcompetencies MC
				INNER JOIN mindmapevidences ME
				ON MC.id = ME.competenceid
				WHERE mindmapid =" .$id;

		//echo $sql;
		return $this->getResultsQuery($sql);
	}*/

	public function getMindMapCompetenciesByIdForStudent($id, $studentid){
		$sql = "SELECT  MC.id AS cid,
						MC.name AS cname,
						ME.id AS eid,
						ME.name AS ename,
						ME.priority AS priority,
						IFNULL(SE.value, 0) as value
				FROM mindmapcompetencies MC
				LEFT JOIN mindmapevidences ME
					ON ME.competenceid = MC.id
				LEFT JOIN studentevidences SE 
					ON SE.evidence = ME.name AND studentid = $studentid
				WHERE mindmapid = $id 
				ORDER BY priority";

		return $this->getResultsQuery($sql);
	}

	public function deleteStudentsEvidences( $studentid, $evidence){
		$sql = "DELETE FROM studentevidences 
				WHERE studentid = $studentid AND evidence='$evidence'";
		echo $sql;
		return $this->executeQuery($sql);
	}

	public function addStudentsEvidences($studentid, $evidence, $value){
		$sql = "INSERT INTO studentevidences(id, studentid, evidence, value) 
				VALUES (NULL, '$studentid', '$evidence', '$value')";
		echo "$sql";
		return $this->executeInsertQuery($sql);
	}

	public function insertUpdateStudentsEvidences($studentid, $evidence, $value){
		$sql = "SELECT * FROM studentevidences WHERE studentid = $studentid AND evidence='$evidence'";

		$row = $this->getResultsQuery($sql);
		//print_r($row);

		if(count($row) > 0){
			$sql = "UPDATE studentevidences SET value = $value 
				WHERE studentid = $studentid AND evidence='$evidence'";
			return $this->executeQuery($sql);
		}else{
			$sql = "INSERT INTO studentevidences(id, studentid, evidence, value) 
				VALUES (NULL, '$studentid', '$evidence', '$value')";
			return $this->executeInsertQuery($sql);
		}

		//echo "$sql";
	}

	public function getCharts($teacherid){
		$sql = "SELECT * FROM mindmap
				WHERE teacherid = $teacherid";
				
		return $this->getResultsQuery($sql);
	}

	public function getChartsById($id){
		return $this->getResultsQuery("SELECT * FROM mindmap WHERE id=" .$id);

	}

	public function addChart($teacherid, $name, $data){
		$sql = "INSERT INTO mindmap(id, teacherid, name, data) 
				VALUES (NULL, '$teacherid', '$name', '$data')";
		$id = $this->executeInsertQuery($sql);

		if($id){
			$this->addChartCompetencesAndEvidences($id, $data);
		}

		return $id;
	}
	

	public function addChartCompetencesAndEvidences($id, $strData){
		$this->deleteChartCompetencesAndEvidences($id);
		
		$json = json_decode($strData);
		
		if(property_exists($json, "ideas")){
			foreach ($json->ideas as $key => $competence) { 

				$cname = $competence->title;

				$sql = "INSERT INTO mindmapcompetencies(id, name, mindmapid) 
							VALUES (NULL, '$cname', $id)";

				$cid = $this->executeInsertQuery($sql);	

				if($cid ){
					if(property_exists($competence, "ideas")){
						foreach ($competence->ideas as $key => $description) {
				            $eveidences = array();
				            
				            if(property_exists($description, "ideas")){
				            	$sql = "INSERT INTO mindmapevidences(id, name, competenceid, priority) 
										VALUES ";
								$i = 0;
				                foreach ($description->ideas as $ekey => $evidence) {
				                    $ename = $evidence->title;
				                    if($i > 0){
				                    	$sql  .= ",";
				                    }

				                    $sql  .= "(NULL, '$ename', $cid, $ekey)";

				                    $i++;
				                }
							
								$eid = $this->executeInsertQuery($sql);	
				            }
			            }
						
			        }
			    }

			}
		}
	}

	public function deleteChartCompetencesAndEvidences($id){
		$sql = "DELETE 
				FROM mindmapevidences
				WHERE competenceid IN 
					(
						SELECT id 
						FROM mindmapcompetencies 
						WHERE mindmapid = $id 
					)"; 
		$this->executeQuery($sql);

		$sql = "DELETE 
				FROM mindmapcompetencies
				WHERE mindmapid  = $id"; 
		
		$this->executeQuery($sql);
		
	}

	public function updateChart($id, $teacherid, $name, $data){
		$espapeData = $this->mysqlEscapeString($data);

		$sql = "UPDATE mindmap
				SET teacherid = '$teacherid',
					name = '$name',
					data = '$espapeData'
				WHERE id = '$id'";

		//echo $sql;
		$res = $this->executeQuery($sql);
		$this->addChartCompetencesAndEvidences($id, $data);
		return $res;
	}

	public function deleteChart($id){
		$sql = "DELETE FROM mindmap WHERE id = $id";
		return $this->executeQuery($sql); 
	}
}
?>